/*
 *      fhist - file history and comparison tools
 *      Copyright (C) 1993, 1994, 1998, 2002, 2005, 2008, 2010 Peter Miller
 *
 *      This program is free software; you can redistribute it and/or modify
 *      it under the terms of the GNU General Public License as published by
 *      the Free Software Foundation; either version 3 of the License, or
 *      (at your option) any later version.
 *
 *      This program is distributed in the hope that it will be useful,
 *      but WITHOUT ANY WARRANTY; without even the implied warranty of
 *      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *      GNU General Public License for more details.
 *
 *      You should have received a copy of the GNU General Public License
 *      along with this program. If not, see
 *      <http://www.gnu.org/licenses/>.
 */

#ifndef WORK_H
#define WORK_H

#include <common/main.h>

extern long     conflicts;      /* number of conflicts */
extern long     failcount;      /* maximum conflicts allowable */
extern long     unchangecount;  /* maximum unchanged lines to output */
extern short    ignoreflag;     /* ignore conflicts */

/*
 * Ignore logical conflicts when the lines of the change on each side
 * are identical.
 */
extern short    ignore_identical;

void fmerge(char *base_name, char *nameA, char *nameB);
void dumpmergedfile(char *outname);
void dumpconflicts(char *outname);
void convertconflicts(char *inname, char *outname);

#endif /* WORK_H */
